#extension GL_OES_EGL_image_external : require
#define RA 0.44
precision mediump float;//精度 为float

varying vec2 vTextureCo;
uniform samplerExternalOES uTexture;
uniform vec3 iResolution;// viewport resolution (in pixels)
uniform vec4 iMouse;// mouse pixel coords. xy: current (if MLB down), zw: click
uniform float scale;
uniform int type;
const float zoom = 1.0;

void main()
{
    float radius;
    if (iResolution.y > iResolution.x){
        radius = RA * iResolution.x * scale;
    } else {
        radius = RA * iResolution.y * scale;
    }
    vec2 position = iMouse.xy;
    if (position.x < radius){
        position.x = radius;
    }
    if (position.x + radius > iResolution.x){
        position.x = iResolution.x - radius;
    }
    if (position.y < radius){
        position.y = radius;
    }
    if (position.y + radius > iResolution.y){
        position.y = iResolution.y - radius;
    }

    vec2 fragCoord = vTextureCo * iResolution.xy;

    //translate
    fragCoord = fragCoord + position - iResolution.xy / 2.0;
    //scale
    fragCoord = ((fragCoord) - position) * scale + position;
    vec2 uv = floor(fragCoord) + 0.5;
    uv += 1.0 - clamp((1.0 - fract(fragCoord)) * zoom, 0.0, 1.0);

    vec4 img = texture2D(uTexture, uv / iResolution.xy);
    gl_FragColor = img;
}