#extension GL_OES_EGL_image_external : require
#define RA 0.46
precision mediump float;//精度 为float

varying vec2 vTextureCo;
uniform samplerExternalOES uTexture;
uniform vec3 iResolution;// viewport resolution (in pixels)
uniform int type;
const float zoom = 1.0;

const int CIRCLE = 1;
const int HEART = 2;
const int FLOWER = 3;
const int HEART_2 = 4;

float heart(vec2 p) {
    p.y += 0.6;
    const float offset = 0.3;
    float k = 1.2 * p.y - sqrt(abs(p.x) + offset);
    return p.x * p.x + k * k - 1.0;
}

float circle(vec2 p){
    return p.x * p.x + p.y * p.y - 1.0;
}

float flower(vec2 p){
    p = p * 0.5;
    float size = 0.33;
    float flowers = 5.0;
    float angle = 3.0;
    float a = atan(p.x, p.y);
    float r = length(p);
    float h = 0.5 + 0.5*cos(flowers*a + angle);
    float d = size + 0.15*pow(h, r);
    return r - d;
}

float roundRectangle(vec2 p, float radius){
    vec2 rectangle = vec2(radius, radius);
    rectangle.y = rectangle.y * 0.7;
    float connerRadius = rectangle.x * 0.27;
    return length(max(abs(p) - rectangle + connerRadius, 0.0)) - connerRadius;
}

void main()
{
    float r = RA;
    if (type == HEART){
        r += 0.04;
    }
    float radius = r * iResolution.x * 1.0;
    vec2 position = iResolution.xy / 2.0;
    vec2 fragCoord = gl_FragCoord.xy;

    vec2 p = (position.xy - fragCoord)/radius;
    vec4 tracolor = vec4(0.0, 0.0, 0.0, 0.0);
    vec4 img = texture2D(uTexture, vTextureCo);

    float dx = 0.0;
    if (type == CIRCLE){
        dx = circle(p);
    }
    if (type == HEART || type == HEART_2){
        dx = heart(p);
    }
    if (type == FLOWER){
        dx = flower(p);
    }

    vec4 col = mix(img, tracolor, smoothstep(0.0, 0.0, dx));
    gl_FragColor = col;
}